from difflib import Differ
from PottyMouth import PottyMouth, Node, LinkNode, EmailNode, ImageNode

contents = (
    ("""
Here is a _paragraph_ with big _fat_ long text lines
that go *on and_ on* forever with no end in sight.

Yes, that's right,  another paragraph. http://google.com/ is my site
* Will wonders ever cease?
""",
     [Node('P',
           Node('span', 'Here is a '),
           Node('i',
                Node('span', 'paragraph'),
                ),
           Node('span', ' with big '),
           Node('i',
                Node('span', 'fat'),
                ),
           Node('span', ' long text lines \nthat go '),
           Node('b',
                Node('span', 'on and\n_\n on'),
                ),
           Node('span', ' forever with no end in sight. ')
           ),
      Node('P',
           Node('span', 'Yes, that&#8217;s right,  another paragraph. '),
           LinkNode('http://google.com/'),
           Node('span', ' is my site \n*\n Will wonders ever cease? '),
           )
      ]
     ),
    ("""
this paragraph
has short
lines so it
should get
break tags
all over the
place
""",
     [Node('P',
           Node('span', 'this paragraph '),
           Node('br'),
           Node('span', 'has short '),
           Node('br'),
           Node('span', 'lines so it '),
           Node('br'),
           Node('span', 'should get '),
           Node('br'),
           Node('span', 'break tags '),
           Node('br'),
           Node('span', 'all over the '),
           Node('br'),
           Node('span', 'place '),
           )
      ]
     ),

    ("""This paragraph has a list embedded in the middle of itself:
item one
item two
item three
See, wasn't that easy?""",
     [Node('P',
           Node('span', 'This paragraph has a list embedded in the middle of itself: '),
           Node('br'),
           Node('span', 'item one '),
           Node('br'),
           Node('span', 'item two '),
           Node('br'),
           Node('span', 'item three '),
           Node('br'),
           Node('span', 'See, wasn&#8217;t that easy?')
           ),
      ]
     ),

    ("""
item one
item two
item three
See, wasn't that easy?""",
     [Node('P',
           Node('span', 'item one '),
           Node('br'),
           Node('span', 'item two '),
           Node('br'),
           Node('span', 'item three '),
           Node('br'),
           Node('span', 'See, wasn&#8217;t that easy?')
           ),
      ]
     ),
    
    ("""This paragraph has a list embedded in the middle of itself:
item one
item two
item thre
""",
     [Node('P',
           Node('span', 'This paragraph has a list embedded in the middle of itself: '),
           Node('br'),
           Node('span', 'item one '),
           Node('br'),
           Node('span', 'item two '),
           Node('br'),
           Node('span', 'item thre '),
           ),
      ]
     ),

    ("""
This paragraph is classic and typical evidence of why the process of hard text
wrapping
was ultimately a short-sighted practice that was deeply, wholly and firmly
grounded
in complete idiocy, sincerely stupid and fallacious techniques and practices
of programming.
""",
     [Node('p',
           Node('span',
                'This paragraph is classic and typical evidence of why the process of hard text \n'
                'wrapping \n'
                'was ultimately a short-sighted practice that was deeply, wholly and firmly \n'
                'grounded \n'
                'in complete idiocy, sincerely stupid and fallacious techniques and practices \n'
                'of programming. '
                ),
           )
      ]
     ),

    ("""
This is a reply to an reply
> this is a reply
> > this is the original
> > and another original line
> > aand yet ononther ariginal
> >
> > more of the original in a different block quote
> more of the reply
>
> even more reply
> wow this just keeps going
rest of the message

no news 
""",
     [ Node('p',
            Node('span', 'This is a reply to an reply '),
            Node('blockquote',
                 Node('p',
                      Node('span', 'this is a reply '),
                      Node('blockquote',
                           Node('p',
                                Node('span', 'this is the original '),
                                Node('br'),
                                Node('span', 'and another original line '),
                                Node('br'),
                                Node('span', 'aand yet ononther ariginal '),
                                )
                           ),
                      Node('blockquote',
                           Node('p',
                                Node('span', 'more of the original in a different block quote '),
                                ),
                           ),
                      Node('span', 'more of the reply '),
                      )
                 ),
            Node('blockquote',
                 Node('p',
                      Node('span', 'even more reply '),
                      Node('br'),
                      Node('span', 'wow this just keeps going ')
                      ),
                 ),
            Node('span', 'rest of the message '),
            ),
       Node('p',
            Node('span', 'no news  ')
            )
       ]
     ),

    ("""You suck
> no, you suck
>> no, really, you suck
>>> I told you, you are the sucky one
> whatever you say

eat shit with your findegs
this iss also shit

eat shit some more """,
     [Node('p',
           Node('span', 'You suck '),
           Node('blockquote',
                Node('p',
                     Node('span', 'no, you suck '),
                     Node('blockquote',
                          Node('p',
                               Node('span', 'no, really, you suck '),
                               Node('blockquote',
                                    Node('p',
                                         Node('span', 'I told you, you are the sucky one ')
                                         ),
                                    ),
                               ),
                          ),
                     Node('span', 'whatever you say '),
                     )
                ),
           ),
      Node('p',
           Node('span', 'eat shit with your findegs '),
           Node('br'),
           Node('span', 'this iss also shit '),
           ),
      Node('p',
           Node('span', 'eat shit some more ')
           ),
      ]
     ),

    (""">>> this begins a deep quote
>>> this ends a deep quote
""",
     [Node('p',
           Node('blockquote',
                Node('p',
                     Node('blockquote',
                          Node('p',
                               Node('blockquote',
                                    Node('p',
                                         Node('span', 'this begins a deep quote '),
                                         Node('br'),
                                         Node('span', 'this ends a deep quote '),
                                         ),
                                    ),
                               ),
                          ),
                     ),
                ),
           ),
                
    ]

     ),
    (""">>>> a very very deep quote
>> not so deep of a quote
>>> middle of the road
> deatherly quotingly
""",
     [Node('p',
           Node('blockquote',
                Node('p',
                     Node('blockquote',
                          Node('p',
                               Node('blockquote',
                                    Node('p',
                                         Node('blockquote',
                                              Node('p',
                                                   Node('span', 'a very very deep quote '),
                                                   ),
                                              ),
                                         ),
                                    ),
                               Node('span', 'not so deep of a quote '),
                               Node('blockquote',
                                    Node('p',
                                         Node('span', 'middle of the road ')
                                         )
                                    ),
                               ),
                          ),
                     Node('span', 'deatherly quotingly '),
                     ),
                ),
           ),
      ]
     ),

    ( """> early in the quote
>>>> deep in the quote
not quoted at all
""",
      [ Node('p',
             Node('blockquote',
                  Node('p',
                       Node('span', 'early in the quote '),
                  
                       Node('blockquote',
                            Node('p',
                                 Node('blockquote',
                                      Node('p',
                                           Node('blockquote',
                                                Node('p',
                                                     Node('span', 'deep in the quote '),
                                                     ),
                                                ),
                                           ),
                                      ),
                                 ),
                            ),
                       ),
                  ),
             Node('span', 'not quoted at all '),
             )
        ]
      ),

    ("""This should be a URL http://mysite.com/allowed/service but this should not be http://mysite.COM/something/dangerous. And finally, these two should also be allowed http://mysite.com/safe/url and http://another.site.com/something/else."""
    ,
     [Node('p',
           Node('span', 'This should be a URL '),
           LinkNode('http://mysite.com/allowed/service', internal=True),
           Node('span', ' but this should not be \nhttp://mysite.COM/something/dangerous\n. And finally, these two should also be allowed '),
           LinkNode('http://mysite.com/safe/url', internal=True),
           Node('span', ' and '),
           LinkNode('http://another.site.com/something/else'),
           Node('span', '.'),
           )
      ]
     ),
    ('fran\xc3\xa7aise'.decode('utf8'),
     [Node('p',
           Node('span', 'fran&#231;aise')
           ),
      ]
     ),
    ("""short line
short line
short line
a very very long line that surpasses the maximum short line length""",
     [Node('p',
           Node('span', 'short line '),
           Node('br'),
           Node('span', 'short line '),
           Node('br'),
           Node('span', 'short line '),
           Node('br'),
           Node('span', 'a very very long line that surpasses the maximum short line length'),
           )
      ]
     ),
    ("""two short lines
all by themselves
""",
     [Node('p',
           Node('span', 'two short lines '),
           Node('br'),
           Node('span', 'all by themselves '),
           )
      ]
     ),
    ("""***just a bold***""",
     [Node('p',
           Node('b',
                Node('span', 'just a bold'),
                ),
           ),
      ]
    ),
    ("""**the Higgs Boson is not bold**""",
     [Node('p',
           Node('span', 'the Higgs Boson is not bold'),
           ),
      ]
    ),
    ("A paragraph separated from the next one with a line\n"
     "    \n"
     "that contains just some whitespace becomes two paragraphs\n",
     [Node('p',
           Node('span', 'A paragraph separated from the next one with a line ')
           ),
      Node('p',
           Node('span', 'that contains just some whitespace becomes two paragraphs ')
           ),
      ]
     ),
    ("A paragraph separated from the next one with a line\n"
     "\t\n"
     "that contains just a tab becomes two paragraphs\n",
     [Node('p',
           Node('span', 'A paragraph separated from the next one with a line ')
           ),
      Node('p',
           Node('span', 'that contains just a tab becomes two paragraphs ')
           ),
      ]
     ),
    ("this is someone's e.mail@email.com address",
     [Node('P',
           Node('span', "this is someone&#8217;s "),
           EmailNode('e.mail@email.com'),
           Node('span', ' address'),
           ),
      ],
     ),
    ("And shit, this http://www.theory.org/~matt/matt-1.jpg is an image.",
     [Node('P',
           Node('span', "And shit, this "),
           ImageNode('http://www.theory.org/~matt/matt-1.jpg'),
           Node('span', " is an image."),
           )
      ]
    ),
    ("http://www.youtube.com/v/PVY5IpSDUYE",
     [Node('p',
           Node('object',
                Node('param',
                     attributes={'name':'movie', 'value':"http://www.youtube.com/v/PVY5IpSDUYE",}
                     ),
                Node('param',
                     attributes={'name':'wmode', 'value':'transparent',}
                     ),
                Node('embed',
                     attributes={'type':'application/x-shockwave-flash',
                                 'wmode':'transparent',
                                 'src':"http://www.youtube.com/v/PVY5IpSDUYE",
                                 'width':425, 'height':350,}
                     ),
                attributes={'width':425, 'height':350,})
           )
      ]
     ),
    ("http://www.youtube.com/watch?v=KKTDRqQtPO8",
     [Node('p',
           Node('object',
                Node('param',
                     attributes={'name':'movie', 'value':"http://www.youtube.com/v/KKTDRqQtPO8",}
                     ),
                Node('param',
                     attributes={'name':'wmode', 'value':'transparent',}
                     ),
                Node('embed',
                     attributes={'type':'application/x-shockwave-flash',
                                 'wmode':'transparent',
                                 'src':"http://www.youtube.com/v/KKTDRqQtPO8",
                                 'width':425, 'height':350,}
                     ),
                attributes={'width':425, 'height':350,}),
           )
      ]
     ),
    ("""Oh my "Gosh," said 'Jonah' and 'Tom.' This "Shure" isn't my idea of Quotes.""",
     [Node('p',
           Node('span',
                "Oh my &#8220;Gosh,&#8221; said &#8216;Jonah&#8217; and &#8216;Tom.&#8217; This &#8220;Shure&#8221; isn&#8217;t my idea of Quotes."
                )
           )
      ]
     ),
     ("""Someone's ``being'' too `clever' with quotes.""",
      [Node('p',
            Node('span',
                 "Someone&#8217;s &#8220;being&#8221; too &#8216;clever&#8217; with quotes."
                ),
            ),
       ]
      ),
     ("Whatever happened -- I wondered -- to Illimunated-Distributed Motherf----ers?",
      [Node('p',
            Node('span',
                 "Whatever happened &#8212; I wondered &#8212; to Illimunated-Distributed Motherf&#8212;&#8212;ers?",
                 )
            )
       ]
      ),
     ("what... I think... nevermind.",
      [Node('p',
            Node('span',
                 "what&#8230; I think&#8230; nevermind."
                 )
            )
       ]
      ),
     ("*http://www.theory.org/ * and _italic http://www.theory.org/ _ and *http://www.theory.org extra stuff*",
      [Node('p',
            Node('b',
                 LinkNode('http://www.theory.org/'),
                 Node('span', " "),
                 ),
            Node('span', " and "),
            Node('i',
                 Node('span', "italic "),
                 LinkNode('http://www.theory.org/'),
                 Node('span', " "),
                 ),
            Node('span', " and "),
            Node('b',
                 LinkNode('http://www.theory.org'),
                 Node('span', ' extra stuff'),
                 ),
            ),
       ]
      ),
     ("this is *bold _and italic *and I dunno* what_ this* is.",
      [Node('p',
            Node('span',
                 "this is "),
            Node('b',
                 Node('span', "bold ", "_", "and italic ",)
                 ),
            Node('span', "and I dunno"),
            Node('b',
                 Node('span', " what", "_", " this"),
                 ),
            Node('span', " is."),
            )
       ]
      ),
     ("but *I dunno _what* this_ is *supposed to* be.",
      [Node('p',
            Node('span', "but "),
            Node('b',
                 Node('span', "I dunno ", "_", "what")
                 ),
            Node('span', " this", "_", " is "),
            Node('b',
                 Node('span', "supposed to")
                 ),
            Node('span', " be.")
            )
       ]
      ),
     # Test attempted HTML insertion
     ('<a href="spleengrokes@email.com" target="_blank">Contact Me</a>',
      [Node('p',
            Node('span', "&lt;a "),
            EmailNode("href="+unichr(8220)+"spleengrokes@email.com"),
            Node('span', "&#8221; target=&#8220;", "_", "blank&#8221;", "&gt;", "Contact Me&lt;/a", "&gt;")
            )
       ]
      ),
     # Test identification of URLs that begin with www.
     ('go to www.google.com but not ww.goggle.com nor goggoil.com nor gar.goyle.com',
      [Node('p',
            Node('span', "go to "),
            LinkNode('http://www.google.com'),
            Node('span', ' but not ww.goggle.com nor goggoil.com nor gar.goyle.com')
            )
       ]
      ),
    )


w = PottyMouth(url_check_domains=('mysite.com',),
               url_white_lists=('https?://mysite\.com/allowed/service',
                                'https?://mysite\.com/safe/url',),
               allow_media=True,
               )
failures = 0
for source, output in contents:#[-1:]:
    blocks = w.parse(source)
    generated = '\n'.join(map(str, blocks))
    expected = '\n'.join(map(str, output))
    if generated != expected:
        failures += 1
        d = Differ()
        result = list(d.compare(generated.split('\n'), expected.split('\n')))
        print '\n'.join(result)
        print '=' * 70

if failures:
    print failures, 'failures'
